clear all;close all;
it=uint32(7);

str1=datestr(now,30);

jg = 0;
%f = figure(3);
%jb = uicontrol('style','push','string','stop','callback','jg=jg+1');
%size = 1000000;


ebno=[0.25 0.75 1.25 1.75];
transmited_bits=100000000000;

dimension=5; % pocet dimenzi paritniho kodu
block_depth=4; % delka strany bloku dat
parity_bits=1; % pocet paritnich bitu

R=(block_depth^dimension)/((block_depth+parity_bits)^dimension);

%%%%%
ber1 = logspace(-9,-0.8,1001);
db1  = 20*log10(erfinv(1-2*ber1));
%%%%%


pe1=uint8(ones(1,1));
pe2=uint8(ones(1,1));
pe3=uint8(ones(1,1));

g1=uint32(zeros(1,1));
g2=uint32(zeros(1,1));
g3=uint32(zeros(1,1));

en1=uint32(zeros(1,1));
en2=uint32(zeros(1,1));
en3=uint32(zeros(1,1));

frame_error_ref=zeros(1,length(ebno));
frame_error_1=uint32(zeros(1,length(ebno)));
frame_error_2=uint32(zeros(1,length(ebno)));
frame_error_3=uint32(zeros(1,length(ebno)));

error_number_ref=uint32(zeros(1,length(ebno)));
error_number_1=uint32(zeros(1,length(ebno)));
error_number_2=uint32(zeros(1,length(ebno)));
error_number_3=uint32(zeros(1,length(ebno)));

increase_frame_error_ref=zeros(1,length(ebno));
increase_frame_error_1=uint32(zeros(1,length(ebno)));
increase_frame_error_2=uint32(zeros(1,length(ebno)));
increase_frame_error_3=uint32(zeros(1,length(ebno)));

increase_error_number_ref=uint32(zeros(1,length(ebno)));
increase_error_number_1=uint32(zeros(1,length(ebno)));
increase_error_number_2=uint32(zeros(1,length(ebno)));
increase_error_number_3=uint32(zeros(1,length(ebno)));

frame_number=zeros(1,length(ebno));
increase_frame_number=zeros(1,length(ebno));

BER_ref=(zeros(1,length(ebno)));
BER_1=single(zeros(1,length(ebno)));
BER_2=single(zeros(1,length(ebno)));
BER_3=single(zeros(1,length(ebno)));
FER_1=single(zeros(1,length(ebno)));
FER_2=single(zeros(1,length(ebno)));
FER_3=single(zeros(1,length(ebno)));
UFER_1=single(zeros(1,length(ebno)));
UFER_2=single(zeros(1,length(ebno)));
UFER_3=single(zeros(1,length(ebno)));

not_det1=uint32(zeros(1,length(ebno)));
not_det2=uint32(zeros(1,length(ebno)));
not_det3=uint32(zeros(1,length(ebno)));

increase_not_det1=uint32(zeros(1,length(ebno)));
increase_not_det2=uint32(zeros(1,length(ebno)));
increase_not_det3=uint32(zeros(1,length(ebno)));

p=(zeros(1,length(ebno)));
increase_p=(zeros(1,length(ebno)));


s0=single(sqrt(2).*bp_Psk(0));
s1=single(sqrt(2).*bp_Psk(1));

y1=logical(bp_Gendata(dimension, block_depth)); % preddefinovani vsech n-dimensionalnich promennych
y2=y1;
y3=y1;

out1=y1;
out2=y1;
out3=y1;

c=0;
limit_frame=100;
index=0;


ind = 0;
ind2 = 0;
nr = [];
writ = 1;

all_size = repmat({':'},1,dimension);
cnt = 0;

while min([frame_error_1(end) frame_error_2(end) frame_error_3(end)])<limit_frame && jg<1
    if (min([frame_error_1(end) frame_error_2(end) frame_error_3(end)]) + 20 > limit_frame)
        limit_frame = limit_frame + 30;
    end;
    cnt = cnt + 1
    c0=mod(c,length(ebno))+1;
    snr=ebno(c0)-33.1133;
    
    y1=bp_Gendata(dimension, block_depth);
    y2=bp_CrossParityBlock(y1, dimension, block_depth);
    [y3]=bp_TransmitDataPsk(y2,snr,s0,s1);
    
    bitM = (block_depth+1)^dimension;
    
    if c0==1
        index=index+1;
    else
    end;
    
    if (min([frame_error_1(c0) frame_error_2(c0) frame_error_3(c0)])<limit_frame) && p(c0)<transmited_bits
        [out1,g1,it1]=bp_Decoding(y3, dimension, block_depth);
        [out2,g2,it2]=bp_DecodHard(y3, dimension, block_depth);
        [out3,g3,it3]=bp_DecodingMix(y3, dimension, block_depth);
        
        en1=nnz(xor(y2,out1));
        en2=nnz(xor(y2,out2));
        en3=nnz(xor(y2,out3));
        
        increase_error_number_ref(c0)=increase_error_number_ref(c0)+nnz(xor(y2,y3));
        
        increase_error_number_1(c0)=increase_error_number_1(c0)+en1;
        increase_error_number_2(c0)=increase_error_number_2(c0)+en2;
        increase_error_number_3(c0)=increase_error_number_3(c0)+en3;
        
        increase_p(c0)=increase_p(c0)+bitM;
        
        if nnz(y2-y3)>0
            increase_frame_error_ref(c0)=increase_frame_error_ref(c0)+1;
        else
        end;
        
        
        if ((en1>0 || en2 > 0 || en3 > 0) && ind < 200)
            ind = ind + 1;
            bp_Matrices1(ind,1,all_size{:}) = y2;
            bp_Matrices1(ind,2,all_size{:}) = y3;
            if (mod(ind,20)==0)
                save(strcat(str1,'_',num2str(dimension),'D',num2str(block_depth),'L','_bp_Matrices1'),'bp_Matrices1');  %posledni cyklus, uloz matice y2 a y3 pro analyzu
            end;
            
            mater=(strcat(str1,'_',num2str(dimension),'D',num2str(block_depth),'L','_bp_DataMatrixesErrors.mat'));
            m = matfile(mater,'Writable',true);
            new_row_of_values = [en1, g1, it1, en2, g2, it2, en3, g3, it3, cnt];
            s = size(nr,1);
            nr(s+1, :) = new_row_of_values;
            WT = true;
            while WT
                
                if isprop(m, 'bp_DataMatrixesErrors')
                    m.bp_DataMatrixesErrors(writ:ind, 1:10) = nr;
                    writ = ind+1;
                else
                    m.bp_DataMatrixesErrors(writ:ind, 1:10) = nr;
                    writ = ind+1;
                end
                nr = [];
                break;
            end
        end;
        
        
        
        if en1>0
            increase_frame_error_1(c0)=increase_frame_error_1(c0)+1;
            pe1=1;
            if g1==0
                increase_not_det1(c0)=increase_not_det1(c0)+1;
            else
            end;
        else
            pe1=0;
        end;
        
        if en2>0
            increase_frame_error_2(c0)=increase_frame_error_2(c0)+1;
            pe2=1;
            if g2==0
                increase_not_det2(c0)=increase_not_det2(c0)+1;
            else
            end;
        else
            pe2=0;
        end;
        
        if en3>0
            increase_frame_error_3(c0)=increase_frame_error_3(c0)+1;
            pe3=1;
            if g3==0
                increase_not_det3(c0)=increase_not_det3(c0)+1;
            else
            end;
        else
            pe3=0;
        end;
        
        increase_frame_number(c0)=increase_p(c0)/bitM;
        
        BER_ref(c0)=single(error_number_ref(c0))/p(c0);
        
        if error_number_1(c0)==0
            BER_1(c0)=10/p(c0);
            FER_1(c0)=1/frame_number(c0);
            UFER_1(c0)=1/frame_number(c0);
        else
            BER_1(c0)=single(error_number_1(c0))/p(c0);
            FER_1(c0)=single(frame_error_1(c0))/frame_number(c0);
            UFER_1(c0)=single(not_det1(c0))/frame_number(c0);
        end
        
        if error_number_2(c0)==0
            BER_2(c0)=10/p(c0);
            FER_2(c0)=1/frame_number(c0);
            UFER_2(c0)=1/frame_number(c0);
        else
            BER_2(c0)=single(error_number_2(c0))/p(c0);
            FER_2(c0)=single(frame_error_2(c0))/frame_number(c0);
            UFER_2(c0)=single(not_det2(c0))/frame_number(c0);
        end
        
        if error_number_3(c0)==0
            BER_3(c0)=10/p(c0);
            FER_3(c0)=1/frame_number(c0);
            UFER_3(c0)=1/frame_number(c0);
        else
            BER_3(c0)=single(error_number_3(c0))/p(c0);
            FER_3(c0)=single(frame_error_3(c0))/frame_number(c0);
            UFER_3(c0)=single(not_det3(c0))/frame_number(c0);
        end
        
        
        
        %frame_number
        %BER_ref
        %frame_error_ref
        %BER_1
        %FER_1
        %UFER_1
        %BER_2
        %FER_2
        %UFER_2
        %         BER_3
        %         FER_3
        %         UFER_3
        frame_error_1
        frame_error_2
        frame_error_3
        frame_number
        
    else
    end;
    
    if (mod(cnt,30)==0)
        filename2=strcat(num2str(dimension),'D',num2str(block_depth),'L','_bp_BerFerValue.mat');
        
        
        WT = true;
        while WT
            if (bp_CreateWriteLock(str1))
                
                m2 = matfile(filename2,'Writable',true);
                if isprop(m2, 'frame_error_ref')
                    frame_error_ref=m2.frame_error_ref;
                    frame_error_1=m2.frame_error_1;
                    frame_error_2=m2.frame_error_2;
                    frame_error_3=m2.frame_error_3;
                    error_number_ref=m2.error_number_ref;
                    error_number_1=m2.error_number_1;
                    error_number_2=m2.error_number_2;
                    error_number_3=m2.error_number_3;
                    not_det1=m2.not_det1;
                    not_det2=m2.not_det2;
                    not_det3=m2.not_det3;
                    p=m2.p;
                    frame_number=m2.frame_number;
                    
                    m2.frame_error_ref=frame_error_ref+increase_frame_error_ref;
                    m2.frame_error_1=frame_error_1+increase_frame_error_1;
                    m2.frame_error_2=frame_error_2+increase_frame_error_2;
                    m2.frame_error_3=frame_error_3+increase_frame_error_3;
                    m2.error_number_ref=error_number_ref+increase_error_number_ref;
                    m2.error_number_1=error_number_1+increase_error_number_1;
                    m2.error_number_2=error_number_2+increase_error_number_2;
                    m2.error_number_3=error_number_3+increase_error_number_3;
                    m2.not_det1=not_det1+increase_not_det1;
                    m2.not_det2=not_det2+increase_not_det2;
                    m2.not_det3=not_det3+increase_not_det3;
                    m2.p=p+increase_p;
                    m2.frame_number=frame_number+increase_frame_number;
                    
                    increase_frame_error_ref=zeros(1,length(ebno));
                    increase_frame_error_1=uint32(zeros(1,length(ebno)));
                    increase_frame_error_2=uint32(zeros(1,length(ebno)));
                    increase_frame_error_3=uint32(zeros(1,length(ebno)));
                    increase_error_number_ref=uint32(zeros(1,length(ebno)));
                    increase_error_number_1=uint32(zeros(1,length(ebno)));
                    increase_error_number_2=uint32(zeros(1,length(ebno)));
                    increase_error_number_3=uint32(zeros(1,length(ebno)));
                    increase_not_det1=uint32(zeros(1,length(ebno)));
                    increase_not_det2=uint32(zeros(1,length(ebno)));
                    increase_not_det3=uint32(zeros(1,length(ebno)));
                    increase_p=(zeros(1,length(ebno)));
                    increase_frame_number=zeros(1,length(ebno));
                    
                else
                    m2.frame_error_ref=frame_error_ref+increase_frame_error_ref;
                    m2.frame_error_1=frame_error_1+increase_frame_error_1;
                    m2.frame_error_2=frame_error_2+increase_frame_error_2;
                    m2.frame_error_3=frame_error_3+increase_frame_error_3;
                    m2.error_number_ref=error_number_ref+increase_error_number_ref;
                    m2.error_number_1=error_number_1+increase_error_number_1;
                    m2.error_number_2=error_number_2+increase_error_number_2;
                    m2.error_number_3=error_number_3+increase_error_number_3;
                    m2.not_det1=not_det1+increase_not_det1;
                    m2.not_det2=not_det2+increase_not_det2;
                    m2.not_det3=not_det3+increase_not_det3;
                    m2.p=p+increase_p;
                    m2.frame_number=frame_number+increase_frame_number;
                    
                    increase_frame_error_ref=zeros(1,length(ebno));
                    increase_frame_error_1=uint32(zeros(1,length(ebno)));
                    increase_frame_error_2=uint32(zeros(1,length(ebno)));
                    increase_frame_error_3=uint32(zeros(1,length(ebno)));
                    increase_error_number_ref=uint32(zeros(1,length(ebno)));
                    increase_error_number_1=uint32(zeros(1,length(ebno)));
                    increase_error_number_2=uint32(zeros(1,length(ebno)));
                    increase_error_number_3=uint32(zeros(1,length(ebno)));
                    increase_not_det1=uint32(zeros(1,length(ebno)));
                    increase_not_det2=uint32(zeros(1,length(ebno)));
                    increase_not_det3=uint32(zeros(1,length(ebno)));
                    increase_p=(zeros(1,length(ebno)));
                    increase_frame_number=zeros(1,length(ebno));
                end
                clear m2;
                bp_DeleteWriteLock(); % Delete lock
                ind2 = 0;
                break;
            else
                pause(1.5);
            end
        end
    end
    c=c+1;
end


%v pripade ze dobehne program, uloz posledni hodnoty
filename2=strcat(num2str(dimension),'D',num2str(block_depth),'L','_bp_BerFerValue.mat');
m2 = matfile(filename2,'Writable',true);

WT = true;
while WT
    if(bp_CreateWriteLock(str1))
        
        if isprop(m2, 'bp_BerFerValue')
            frame_error_ref=m2.frame_error_ref;
            frame_error_1=m2.frame_error_1;
            frame_error_2=m2.frame_error_2;
            frame_error_3=m2.frame_error_3;
            error_number_ref=m2.error_number_ref;
            error_number_1=m2.error_number_1;
            error_number_2=m2.error_number_2;
            error_number_3=m2.error_number_3;
            not_det1=m2.not_det1;
            not_det2=m2.not_det2;
            not_det3=m2.not_det3;
            p=m2.p;
            
            m2.frame_error_ref=frame_error_ref+increase_frame_error_ref;
            m2.frame_error_1=frame_error_1+increase_frame_error_1;
            m2.frame_error_2=frame_error_2+increase_frame_error_2;
            m2.frame_error_3=frame_error_3+increase_frame_error_3;
            m2.error_number_ref=error_number_ref+increase_error_number_ref;
            m2.error_number_1=error_number_1+increase_error_number_1;
            m2.error_number_2=error_number_2+increase_error_number_2;
            m2.error_number_3=error_number_3+increase_error_number_3;
            m2.not_det1=not_det1+increase_not_det1;
            m2.not_det2=not_det2+increase_not_det2;
            m2.not_det3=not_det3+increase_not_det3;
            m2.p=p+increase_p;
            
            increase_frame_error_ref=uint32(zeros(1,length(ebno)));
            increase_frame_error_1=uint32(zeros(1,length(ebno)));
            increase_frame_error_2=uint32(zeros(1,length(ebno)));
            increase_frame_error_3=uint32(zeros(1,length(ebno)));
            increase_error_number_ref=uint32(zeros(1,length(ebno)));
            increase_error_number_1=uint32(zeros(1,length(ebno)));
            increase_error_number_2=uint32(zeros(1,length(ebno)));
            increase_error_number_3=uint32(zeros(1,length(ebno)));
            increase_not_det1=uint32(zeros(1,length(ebno)));
            increase_not_det2=uint32(zeros(1,length(ebno)));
            increase_not_det3=uint32(zeros(1,length(ebno)));
            increase_p=(zeros(1,length(ebno)));
        else
            m2.frame_error_ref=frame_error_ref+increase_frame_error_ref;
            m2.frame_error_1=frame_error_1+increase_frame_error_1;
            m2.frame_error_2=frame_error_2+increase_frame_error_2;
            m2.frame_error_3=frame_error_3+increase_frame_error_3;
            m2.error_number_ref=error_number_ref+increase_error_number_ref;
            m2.error_number_1=error_number_1+increase_error_number_1;
            m2.error_number_2=error_number_2+increase_error_number_2;
            m2.error_number_3=error_number_3+increase_error_number_3;
            m2.not_det1=not_det1+increase_not_det1;
            m2.not_det2=not_det2+increase_not_det2;
            m2.not_det3=not_det3+increase_not_det3;
            m2.p=p+increase_p;
            
            increase_frame_error_ref=uint32(zeros(1,length(ebno)));
            increase_frame_error_1=uint32(zeros(1,length(ebno)));
            increase_frame_error_2=uint32(zeros(1,length(ebno)));
            increase_frame_error_3=uint32(zeros(1,length(ebno)));
            increase_error_number_ref=uint32(zeros(1,length(ebno)));
            increase_error_number_1=uint32(zeros(1,length(ebno)));
            increase_error_number_2=uint32(zeros(1,length(ebno)));
            increase_error_number_3=uint32(zeros(1,length(ebno)));
            increase_not_det1=uint32(zeros(1,length(ebno)));
            increase_not_det2=uint32(zeros(1,length(ebno)));
            increase_not_det3=uint32(zeros(1,length(ebno)));
            increase_p=(zeros(1,length(ebno)));
        end
        bp_DeleteWriteLock();
        break; % Wait before writing more data
    else
        pause(1.5);
    end
end



