clear all;close all;
str1=datestr(now,30);

dimension=5; % pocet dimenzi paritniho kodu
block_depth=4; % delka strany bloku dat
parity_bits=1; % pocet paritnich bitu
R=(block_depth^dimension)/((block_depth+parity_bits)^dimension);

jg = 0;
f = figure(5);
jb = uicontrol('style','push','string','stop','callback','jg=jg+1');
size = 1000000;

ebno=[0.25 0.75 1.25 1.75];

%%%%%
ber1 = logspace(-9,-0.8,1001);
db1  = 20*log10(erfinv(1-2*ber1));
%%%%%


WT = true;
filename2=strcat(num2str(dimension),'D',num2str(block_depth),'L','_bp_BerFerValue.mat');

while(exist(filename2,'file')==false)
    pause(5);
end
while WT
    drawnow;
    if (bp_CreateWriteLock(str1))
        
        
        data = matfile(filename2);
        pause(0.5)
        
        
        
        BER_1=single(data.error_number_1)./data.p;
        FER_1=single(data.frame_error_1)./data.frame_number;
        UFER_1=single(data.not_det1)./data.frame_number;
        
        BER_2=single(data.error_number_2)./data.p;
        FER_2=single(data.frame_error_2)./data.frame_number;
        UFER_2=single(data.not_det2)./data.frame_number;
        
        BER_3=single(data.error_number_3)./data.p;
        FER_3=single(data.frame_error_3)./data.frame_number;
        UFER_3=single(data.not_det3)./data.frame_number;
        
        
        figure(5);
        semilogy(db1,ber1,'y',ebno+10*log10(1/R),BER_1,'r',ebno+10*log10(1/R),BER_2,'g',ebno+10*log10(1/R),BER_3,'b');
        legend('BER_ref','BER1','BER2','BER3');
        

        
        clear data
        pause(1);
        bp_DeleteWriteLock();
        
        pause(60); %pauza mezi ctenim dat
    else
        pause (1.5);
    end;
end